Package: gcapc
Title: GC Aware Peak Caller
Version: 1.37.0
Author: Mingxiang Teng and Rafael A. Irizarry
Maintainer: Mingxiang Teng <tengmx@gmail.com>
Description: Peak calling for ChIP-seq data with
    consideration of potential GC bias in sequencing
    reads. GC bias is first estimated with generalized
    linear mixture models using effective GC strategy,
    then applied into peak significance estimation.
Depends: R (>= 3.4)
Imports: BiocGenerics, Seqinfo, S4Vectors, IRanges, Biostrings,
        BSgenome, GenomicRanges, Rsamtools, GenomicAlignments,
        matrixStats, MASS, splines, grDevices, graphics, stats, methods
VignetteBuilder: knitr
Suggests: BiocStyle, knitr, rmarkdown, BSgenome.Hsapiens.UCSC.hg19,
        BSgenome.Mmusculus.UCSC.mm10
URL: https://github.com/tengmx/gcapc
License: GPL-3
biocViews: Sequencing, ChIPSeq, BatchEffect, PeakDetection
RoxygenNote: 6.0.1
git_url: https://git.bioconductor.org/packages/gcapc
git_branch: devel
git_last_commit: 16b89e7
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 22:46:29 UTC; biocbuild

# gcapc: GC effects aware peak caller

### Introduction
ChIP-seq has been widely utilized as the standard technology to detect 
protein binding regions, where peak calling algorithms were developed 
particularly to serve the analysis. Existing peak callers lack of power 
on ranking peaks' significance due to sequencing technology might undergo
sequence context biases, *e.g.* GC bias. *gcapc* is designed to address 
this deficiency by modeling GC effects into peak calling.

### Installation

*gcapc* is an R/Bioconductor package, which can be installed with source
code documented in [GitHub](https://github.com/tengmx/gcapc) or simply
through [Bioconductor](https://bioconductor.org/packages/gcapc).

If GitHub source installation is selected, make sure dependency
R packages are pre-installed as shown in the
[DESCRIPTION](https://github.com/tengmx/gcapc/blob/master/DESCRIPTION) file.
Then, install *gcapc* with following code.
```s
library(devtools)
install_github("tengmx/gcapc")
```

Alternatively, installation through Bioconductor is as simple as follows.
```s
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("gcapc")
```

### Using *gcapc*

First, load the package into R.
```s
library(gcapc)
```

Then, follow the steps introduced in the package 
[vignette](https://bioconductor.org/packages/devel/bioc/vignettes/gcapc/inst/doc/gcapc.html)
to estimate GC-bias or peak calling.

### Help

You are very welcome to leave any questions/bug messages at
[GitHub issues](https://github.com/tengmx/gcapc/issues).

#' @title Reads Coverage Using 5-end Base
#'
#' @description
#' Reads coverage in single base pair resolution using only 5-prime end
#' of BAM file records. Coverages are reported for forward and reverse
#' strands separately. Options for customized filtering of BAM records
#' are provided.
#'
#' @param bam The path to a BAM file, which is sorted and indexed.
#'
#' @param chroms NULL or a vector of chromosome names that compatible with
#' the provided BAM file. Reads coverage will be generated for these
#' chromosomes. Default (NULL) will use all chromosomes in BAM file.
#'
#' @param mapq A non-negative integer specifying the minimum mapping
#' quality to include. BAM records with mapping qualities less
#' than \code{mapq} are discarded.
#'
#' @param duplicate A logical vector which, when FALSE (Default), returns
#' maximum coverage of 1 for every base pair. Reads that start at the same
#' position but on different strands are not treated as duplicates.
#'
#' @param flag A returned object by \code{Rsamtools::scanBamFlag}.
#' Additional options for BAM records filtering.
#'
#' @return A list of two objects by \code{GenomicRanges::coverage}
#' \item{fwd}{Coverage object for forward strand.}
#' \item{rev}{Coverage object for reverse strand.}
#'
#' @import Seqinfo
#' @import S4Vectors
#' @import IRanges
#' @import GenomicRanges
#' @importFrom BiocGenerics strand
#' @importFrom Rsamtools BamFile
#' @importFrom Rsamtools scanBamFlag
#' @importFrom Rsamtools ScanBamParam
#' @importFrom GenomicAlignments readGAlignments
#'
#' @export
#' @examples
#' bam <- system.file("extdata", "chipseq.bam", package="gcapc")
#' read5endCoverage(bam)

read5endCoverage <- function(bam,chroms=NULL,mapq=30L,duplicate=FALSE,
                             flag=scanBamFlag(isUnmappedQuery=FALSE,
                             isSecondaryAlignment=FALSE,
                             isNotPassingQualityControls=FALSE)){
    baminfo <- seqinfo(BamFile(bam))
    if(!is.null(chroms)) {
        if(sum(!(chroms %in% seqlevels(baminfo)))>0)
            stop("chromosome names not compatible with bam files")
        gal <- readGAlignments(bam,param=ScanBamParam(what = "mapq",
                   flag = flag, mapqFilter = mapq,
                   which = GRanges(baminfo)[chroms]))
        gr <- granges(gal)
        seqlevels(gr, pruning.mode="coarse") <- chroms
    }else{
        gal <- readGAlignments(bam,param=ScanBamParam(what = "mapq",
                   flag = flag, mapqFilter = mapq))
        gr <- granges(gal)
    }
    grf <- resize(gr[strand(gr)=="+"],1)
    grr <- resize(gr[strand(gr)=="-"],1)
    covf <- coverage(grf)
    covr <- coverage(grr)
    if(!duplicate) {
        runValue(covf)[runValue(covf)>1] <- 1
        runValue(covr)[runValue(covr)>1] <- 1
    }
    list(fwd=covf,rev=covr)
}

#' @title Adjust ChIP-seq Read Count Table
#'
#' @description
#' For a given set of sites with the same/comparable width, their
#' read count table from multiple samples are adjusted based on
#' potential GC effects. For each sample separately, GC effects are
#' estimated based on their effective GC content and
#' reads count using generalized linear mixture models. Then, count
#' table is adjusted based on estimated GC effects.
#' It it important that the given sites includes both foreground and
#' background regions, see \code{sites} below.
#'
#' @param counts A count matrix with each row corresponding to each element
#' in \code{sites} and each column corresponding to one sample. Every value
#' in the matrix indicates the read counts for one site in one sample. It is
#' noted that since effective GC content is used in this function, it is
#' important to extend either original reads or original \code{sites} to
#' consider reads that 5' starting in \code{flank} regions, when counting
#' sequencing reads.
#'
#' @param sites A GRanges object with length equivalent to number of rows
#' in \code{counts} matrix. It is preferable that every GRange have the same
#' width; otherwise, the mixture model is modeling different things with
#' wider GRanges certainly have more reads. However, it is OK if only a
#' minority of GRanges have different width, since the model is pretty robust
#' to outliers. Also, it is important that \code{sites} including both
#' foreground and background regions in each sample, otherwise the mixture
#' model will fail to fit two components. Fortunately, if you are inputing
#' a large collection of samples, foreground sites in one sample may play
#' the role as background in other samples. In this case, manually selecting
#' real background is not necessary.
#'
#' @param flank A non-negative integer specifying the flanking width of
#' ChIP-seq binding. This parameter provides the flexibility that reads
#' appear in flankings by decreased probabilities as increased distance
#' from binding region. This paramter helps to define effective GC
#' content calculation.
#'
#' @param outputidx A logical vector with the length equivalent to number
#' of rows in \code{counts}. This provides which subset of adjusted count
#' matrix should be outputed. This would be extremely useful if you have
#' manually collected background sites and want to only export the sites
#' you care about.
#'
#' @param gcrange A non-negative numeric vector with length 2. This vector
#' sets the range of GC content to filter regions for GC effect estimation.
#' For human, most regions have GC content between 0.3 and 0.8, which is
#' set as the default. Other regions with GC content beyond this range
#' will be ignored. This range is critical when very few foreground regions
#' are selected for mixture model fitting, since outliers could drive the
#' regression lines. Thus, if possible, first make a scatter plot between
#' counts and GC content to decide  this parameter. Alternatively,
#' select a narrower range, e.g. c(0.35,0.7), to aviod outlier effects from
#' both high and low GC-content regions.
#'
#' @param emtrace A logical vector which, when TRUE (default), allows to
#' print the trace of log likelihood changes in EM iterations.
#'
#' @param plot A logical vector which, when TRUE (default), returns miture
#' fitting plot.
#'
#' @param model A character specifying the distribution model to be used in
#' generalized linear model fitting. The default is negative
#' binomial(\code{nbinom}), while \code{poisson} is also supported currently.
#' More details see \code{gcEffects}.
#'
#' @param mu0 A non-negative numeric initiating read count signals for
#' background sites. This is treated as the starting value of background mean
#' for poisson/nbinom fitting.
#'
#' @param mu1 A non-negative numeric initiating read count signals for
#' foreground sites. This is treated as the starting value of foreground mean
#' for poisson/nbinom fitting.
#'
#' @param theta0 A non-negative numeric initiating the shape parameter of
#' negative binomial model for background sites. For more detail, see
#' theta in \code{\link[MASS]{glm.nb}} function.
#'
#' @param theta1 A non-negative numeric initiating the shape parameter of
#' negative binomial model for foreground sites. For more detail, see
#' theta in \code{\link[MASS]{glm.nb}} function.
#'
#' @param p A non-negative numeric specifying the proportion of foreground
#' sites in all estimated sites. This is treated as a starting value for
#' EM algorithm.
#'
#' @param converge A non-negative numeric specifying the condition of EM
#' algorithm termination. EM algorithm stops when the ratio of log likelihood
#' increment to whole log likelihood is less or equivalent to
#' \code{converge}.
#'
#' @param genome A \link[BSgenome]{BSgenome} object containing the sequences
#' of the reference genome that was used to align the reads, or the name of
#' this reference genome specified in a way that is accepted by the
#' \code{\link[BSgenome]{getBSgenome}} function defined in the \pkg{BSgenome}
#' software package. In that case the corresponding BSgenome data package
#' needs to be already installed (see \code{?\link[BSgenome]{getBSgenome}} in
#' the \pkg{BSgenome} package for the details).
#'
#' @param gctype A character vector specifying choice of method to calculate
#' effective GC content. Default \code{ladder} is based on uniformed fragment
#' distribution. A more smoother method based on tricube assumption is also
#' allowed. However, tricube should be not used if \code{flank} is too large.
#'
#' @return The count matrix after GC adjustment. The matrix values are not
#' integer any more.
#'
#' @import S4Vectors
#' @import IRanges
#' @import GenomicRanges
#' @import Biostrings
#' @import MASS
#' @importFrom BSgenome getBSgenome
#' @importFrom BSgenome getSeq
#' @importFrom matrixStats colMedians
#' @importFrom splines ns
#' @importFrom grDevices rgb
#' @importFrom graphics plot
#' @importFrom graphics axis
#' @importFrom graphics lines
#' @importFrom stats dpois
#' @importFrom stats dnbinom
#' @importFrom stats glm
#' @importFrom stats predict
#'
#' @export


refineSites <- function(counts,sites,flank=250L,
                        outputidx=rep(TRUE,nrow(counts)),
                        gcrange=c(0.3,0.8),emtrace=TRUE,plot=TRUE,
                        model=c('nbinom','poisson'),
                        mu0=1,mu1=50,theta0=mu0,theta1=mu1,
                        p=0.2,converge=1e-4,
                        genome="hg19",gctype=c("ladder","tricube")){
    ### input sanity check
    genome <- getBSgenome(genome)
    model <- match.arg(model)
    gctype <- match.arg(gctype)
    sitew <- median(width(sites))
    if(sum(gcrange<0)>0 || sum(gcrange>1)>0 || sum(is.na(gcrange))>0)
        stop("Parameter 'gcrange' error.\n")
    if(mu0<=0 || mu1<=0 || mu0>=mu1)
        stop("Parameter 'mu0' or 'mu1' error.\n")
    if(model=='nbinom' && (theta1<=0 || theta0<=0))
        stop("Parameter 'theta0' or 'theta1' error in nbinom model.\n")
    if(p<=0 || p>=1)
        stop("'p' must be in (0,1).\n")
    if(converge<=0 || converge>0.1)
        stop("'converge' must be in (0,0.1].\n")
    if(gctype=="ladder"){
        weight <- c(seq_len(flank),rep(flank+1,sitew),rev(seq_len(flank)))
        weight <- weight/sum(weight)
    }else if(gctype=="tricube"){
        w <- flank+floor(sitew/2)
        weight <- (1-abs(seq(-w,w)/w)^3)^3
        weight <- weight/sum(weight)
    }
    ### effective gc content
    cat("Start to estimate GC effects.\n")
    cat("...... Calculating GC content with flanking",flank,"\n")
    nr <- shift(resize(sites,width(sites) + flank*2),-flank)
    seqs <- getSeq(genome,nr)
    gcpos <- startIndex(vmatchPattern("S", seqs, fixed="subject"))
    gc <- round(sapply(gcpos,function(x) sum(weight[x])),3)
    rm(nr,seqs,gcpos)
    ### em algorithms
    cat("...... Estimating GC effects\n")
    fitmu0 <- fitmu1 <- fitz <- matrix(NA,sum(outputidx),ncol(counts))
    for(rep in seq_len(ncol(counts))){
        cat("......... Estimating sample",rep,"\n")
        rc <- counts[,rep]
        idx <- gc>=gcrange[1] & gc<=gcrange[2] & !is.na(rc) & !is.na(gc)
        dat <- data.frame(y=rc[idx],gc=gc[idx])
        theta1E <- theta1
        theta0E <- theta0
        if(model=='poisson'){
            logp1 <- dpois(dat$y, lambda = mu1, log = TRUE)
            logp0 <- dpois(dat$y, lambda = mu0, log = TRUE)
        }else{
            logp1 <- dnbinom(dat$y, size=theta1E, mu=mu1, log = TRUE)
            logp0 <- dnbinom(dat$y, size=theta0E, mu=mu0, log = TRUE)
        }
        z <- 1/(1+exp(logp0-logp1)*(1-p)/p)
        llf <- sum(z*(logp1+log(p)) + (1-z)*(logp0+log(1-p)))
        llgap <- llf
        i <- 0
        while(abs(llgap) > (abs(llf) * converge) && i < 100){
            p <- (2+sum(z))/(2*2+length(z))
            dat1 <- dat[z>=0.5,]
            dat0 <- dat[z<0.5,]
            if(model=='poisson'){
                lmns0 <- glm(y ~ ns(gc, df = 2), data=dat0, family="poisson")
                lmns1 <- glm(y ~ ns(gc, df = 2), data=dat1, family="poisson")
                predY0 <- predict(lmns0,data.frame(gc=dat$gc),type="response")
                predY1 <- predict(lmns1,data.frame(gc=dat$gc),type="response")
                logp1 <- dpois(dat$y, lambda = predY1, log = TRUE)
                logp0 <- dpois(dat$y, lambda = predY0, log = TRUE)
            }else{
                lmns0 <- glm.nb(y ~ ns(gc, df=2),data=dat0,init.theta=theta0E)
                lmns1 <- glm.nb(y ~ ns(gc, df=2),data=dat1,init.theta=theta1E)
                predY0 <- predict(lmns0,data.frame(gc=dat$gc),type="response")
                predY1 <- predict(lmns1,data.frame(gc=dat$gc),type="response")
                theta1E <- lmns1$theta
                theta0E <- lmns0$theta
                logp1 <- dnbinom(dat$y, size=theta1E, mu=predY1, log = TRUE)
                logp0 <- dnbinom(dat$y, size=theta0E, mu=predY0, log = TRUE)
            }
            z <- 1/(1+exp(logp0-logp1)*(1-p)/p)
            if(sum(z>=0.5) < length(gc)*0.0005 | sum(z<0.5) < length(gc)*0.0005)
                break;
            lli <- sum(z*(logp1+log(p)) + (1-z)*(logp0+log(1-p)))
            llgap <- lli - llf
            llf <- lli
            i <- i + 1
            if(emtrace)
                cat("......... Iteration",i,'\tll',llf,'\tincrement',llgap,'\n')
        }
        if(plot){
            idx0 <- sample.int(nrow(dat),min(50000,nrow(dat)))
            plot(dat$gc[idx0],dat$y[idx0]+0.5,col=rgb(0,0,0,alpha=0.1),
                 xlim=gcrange,pch=20,main=paste("rep",rep),log='y',yaxt='n',
                 xlab='Effective GC content',ylab="Read counts")
            idx00 <- sample.int(nrow(dat),min(1000,nrow(dat)))
            idx00 <- idx00[order(dat$gc[idx00])]
            lines(dat$gc[idx00],predY1[idx00]+0.5,col='red',lwd=3)
            lines(dat$gc[idx00],predY0[idx00]+0.5,col='blue',lwd=3)
            axis(side=2, at=c(0,2^(0:10))+0.5, labels=c(0,2^(0:10)))
        }
        ### gc effects
        fitmu0[idx[outputidx],rep] <- predY0[outputidx[idx]]
        fitmu1[idx[outputidx],rep] <- predY1[outputidx[idx]]
        fitz[idx[outputidx],rep] <- z[outputidx[idx]]
        cat("......... Sample",rep,"finished\n")
    }
    med1 <- fitmu1
    med0 <- fitmu0
    med1[fitz<0.5] <- NA
    med0[fitz<0.5] <- NA
    gce <- log2(t(t(fitmu1)/colMedians(med1,na.rm=TRUE))) * fitz +
           log2(t(t(fitmu0)/colMedians(med0,na.rm=TRUE))) * (1-fitz)
    counts[outputidx,] / 2^gce
}

#' @title Refine Peaks with GC Effects
#'
#' @description
#' This function refines the ranks (i.e. significance/pvalue) of
#' pre-determined peaks by potential GC effects. These peaks can be
#' obtained from other peak callers, e.g. MACS or SPP.
#'
#' @param coverage A list object returned by function \code{read5endCoverage}.
#'
#' @param gcbias A list object returned by function \code{gcEffects}.
#'
#' @param bdwidth A non-negative integer vector with two elements
#' specifying ChIP-seq binding width and peak detection half window size.
#' Usually generated by function \code{bindWidth}. A bad estimation of
#' bdwidth results no meaning of downstream analysis. The values
#' need to be the same as it is when calculating \code{gcbias}.
#'
#' @param peaks A GRanges object specifying the peaks to be refined.
#' A flexible set of peaks are preferred to reduce potential false
#' negative, meaning both significant (e.g. p<=0.05) and non-significant
#' (e.g. p>0.05) peaks are preferred to be included. If the total
#' number of peaks is not too big, a reasonable set of peaks include
#' all those with p-value/FDR less than 0.99 by other peak callers.
#'
#' @param flank A non-negative integer specifying the flanking width of
#' ChIP-seq binding. This parameter provides the flexibility that reads
#' appear in flankings by decreased probabilities as increased distance
#' from binding region. This paramter helps to define effective GC
#' content calculation. Default is NULL, which means this paramater will
#' be calculated from \code{bdwidth}. However, if customized numbers
#' provided, there won't be recalucation for this parameter; instead, the
#' 2nd elements of \code{bdwidth} will be recalculated based on \code{flank}.
#' The value needs to be the same as it is when calculating \code{gcbias}.
#'
#' @param permute A non-negative integer specifying times of permutation to
#' be performed. Default is 5. When whole large genome is used, such as
#' human genome, 5 times of permutation could be enough.
#'
#' @param genome A \link[BSgenome]{BSgenome} object containing the sequences
#' of the reference genome that was used to align the reads, or the name of
#' this reference genome specified in a way that is accepted by the
#' \code{\link[BSgenome]{getBSgenome}} function defined in the \pkg{BSgenome}
#' software package. In that case the corresponding BSgenome data package
#' needs to be already installed (see \code{?\link[BSgenome]{getBSgenome}} in
#' the \pkg{BSgenome} package for the details). The value needs to be the same
#' as it is when calculating \code{gcbias}.
#'
#' @param gctype A character vector specifying choice of method to calculate
#' effective GC content. Default \code{ladder} is based on uniformed fragment
#' distribution. A more smoother method based on tricube assumption is also
#' allowed. However, tricube should be not used if estimated peak half size
#' is 3 times or more larger than estimated bind width. The value
#' needs to be the same as it is when calculating \code{gcbias}.
#'
#' @return A GRanges object the same as \code{peaks} with two additional
#' meta columns:
#' \item{newes}{Refined enrichment scores.}
#' \item{newpv}{Refined pvalues.}
#'
#' @import S4Vectors
#' @import IRanges
#' @import GenomicRanges
#' @import Biostrings
#' @importFrom BSgenome getBSgenome
#' @importFrom BSgenome getSeq
#' @importFrom methods as
#'
#' @export
#' @examples
#' bam <- system.file("extdata", "chipseq.bam", package="gcapc")
#' cov <- read5endCoverage(bam)
#' bdw <- bindWidth(cov)
#' gcb <- gcEffects(cov, bdw, sampling = c(0.15,1))
#' peaks <- gcapcPeaks(cov, gcb, bdw)
#' refinePeaks(cov, gcb, bdw, peaks)

refinePeaks <- function(coverage,gcbias,bdwidth,peaks,flank=NULL,
                        permute=5L,genome="hg19",
                        gctype=c("ladder","tricube")){
    genome <- getBSgenome(genome)
    gctype <- match.arg(gctype)
    bdw <- bdwidth[1]
    halfbdw <- floor(bdw/2)
    if(is.null(flank)){
        pdwh <- bdwidth[2]
        flank <- pdwh-bdw+halfbdw
    }else{
        pdwh <- flank+bdw-halfbdw
    }
    if(gctype=="ladder"){
      weight <- c(seq_len(flank),rep(flank+1,bdw),rev(seq_len(flank)))
      weight <- weight/sum(weight)
    }else if(gctype=="tricube"){
      w <- flank+halfbdw
      weight <- (1-abs(seq(-w,w)/w)^3)^3
      weight <- weight/sum(weight)
    }
    peaks <- sort(shift(resize(peaks,width(peaks)+bdw),-halfbdw))
    cat("Starting to refine peaks.\n")
    startp <- start(peaks) - 3*halfbdw - 2*flank
    endp <- end(peaks) + 3*halfbdw + 2*flank
    idx <- endp <= seqlengths(genome)[as.character(seqnames(peaks))] &
        startp >= 1
    if(sum(!idx)>0) {
        cat(paste("remove",sum(!idx),
                              "peaks located at chromosome ends\n"))
        peaks <- peaks[idx]
    }
    ### extending regions
    cat("...... extending peaks\n")
    regionsrc <- shift(resize(peaks,width(peaks)+halfbdw*4+flank*2+1),
                              -halfbdw*2-flank)
    seqlevels(regionsrc,pruning.mode="coarse") <- names(coverage$fwd)
    regionsgc <- shift(resize(regionsrc,width(regionsrc)+halfbdw*2),-halfbdw)
    ### gc content
    cat("...... caculating GC content\n")
    nr <- shift(resize(regionsgc,width(regionsgc)+flank*2),-flank)
    seqs <- getSeq(genome,nr)
    gcpos <- startIndex(vmatchPattern("S", seqs, fixed="subject"))
    gcposb <- vector("integer",sum(as.numeric(width(nr))))
    gcposbi <- rep(seq_along(nr),times=width(nr))
    gcposbsp <- split(gcposb,gcposbi)
    for(i in seq_along(nr)){
        gcposbsp[[i]][gcpos[[i]]] <- 1L
    }
    gcposbsprle <- as(gcposbsp,"RleList")
    gcnuml <- width(regionsgc)-halfbdw*2
    gcnum <- vector('numeric',sum(as.numeric(gcnuml)))
    gcnumi <- rep(seq_along(nr),times=gcnuml)
    gc <- split(gcnum,gcnumi)
    for(i in seq_along(nr)){
        gc[[i]] <- round(runwtsum(gcposbsprle[[i]],k=length(weight),
                       wt=weight),3)
        if(i%%500 == 0) cat('.')
    }
    cat('\n')
    rm(regionsgc,nr,seqs,gcpos,gcposb,gcposbi,
        gcposbsp,gcposbsprle,gcnuml,gcnum,gcnumi)
    ### gc weight
    cat("...... caculating GC effect weights\n")
    gcwbase0 <- round(Rle(gcbias$mu0med1/gcbias$mu0),3)
    gcw <- RleList(lapply(gc,function(x) gcwbase0[x*1000+1])) # slow
    rm(gc,gcwbase0)
    ### reads count
    regionrcsp <- split(regionsrc,seqnames(regionsrc))
    rcfwd <- RleList(unlist(viewApply(Views(coverage$fwd,ranges(regionrcsp)),
                 runsum,k=pdwh)))
    rcrev <- RleList(unlist(viewApply(Views(coverage$rev,ranges(regionrcsp)),
                 runsum,k=pdwh)))
    ### enrichment score
    cat("...... estimating enrichment score\n")
    esl <- width(regionsrc)-halfbdw*2-flank*2
    ir1 <- IRangesList(start=IntegerList(as.list(rep(1,length(esl)))),
               end=IntegerList(as.list(esl)))
    ir2 <- IRangesList(start=IntegerList(as.list(rep(1+halfbdw+flank,
               length(esl)))),end=halfbdw+flank+IntegerList(as.list(esl)))
    ir3 <- IRangesList(start=IntegerList(as.list(rep(1+halfbdw*2+flank*2,
               length(esl)))),
               end=halfbdw*2+flank*2+IntegerList(as.list(esl)))
    rc1 <- rcfwd[ir1]
    rc2 <- rcfwd[ir2]
    rc3 <- rcrev[ir1]
    rc4 <- rcrev[ir2]
    gcw1 <- gcw[ir2]
    gcw2 <- gcw[ir3]
    gcw3 <- gcw[ir1]
    esrlt <- round(2*sqrt(rc1*rc4)*gcw1-rc3*gcw3-rc2*gcw2,3)
    names(esrlt) <- seq_along(regionsrc)
    rm(rcfwd,rcrev,gcw,rc1,rc2,rc3,rc4)
    ### permutation analysis
    cat("...... permutation analysis\n")
    perm <- table(c())
    for(p in seq_len(permute)){
        covfwdp <- coverage$fwd[ranges(regionrcsp)]
        covrevp <- coverage$rev[ranges(regionrcsp)]
        for(i in seq_along(coverage$fwd)){
            covfwdp[[i]] <- covfwdp[[i]][sample.int(length(covfwdp[[i]]))]
            covrevp[[i]] <- covrevp[[i]][sample.int(length(covrevp[[i]]))]
        }
        end <- cumsum(width(regionrcsp))
        start <- end-width(regionrcsp)+1
        regionrcspp <- IRangesList(start=start,end=end)
        rcfwdp <- RleList(unlist(viewApply(Views(covfwdp,regionrcspp),
                                         runsum,k=pdwh)))
        rcrevp <- RleList(unlist(viewApply(Views(covrevp,regionrcspp),
                                         runsum,k=pdwh)))
        rcp1 <- rcfwdp[ir1]
        rcp2 <- rcfwdp[ir2]
        rcp3 <- rcrevp[ir1]
        rcp4 <- rcrevp[ir2]
        accum <- table(unlist(round(2*sqrt(rcp1*rcp4)*gcw1-rcp3*gcw3-
                                    rcp2*gcw2,3),use.names=FALSE))
        n <- intersect(names(perm), names(accum))
        perm <- c(perm[!(names(perm) %in% n)],
                 accum[!(names(accum) %in% n)],
                 perm[n] + accum[n])
        cat('......... permutation',p,'\n')
    }
    perm <- perm[order(as.numeric(names(perm)))]
    pvs <- 1- cumsum(as.numeric(perm))/sum(as.numeric(perm))
    names(pvs) <- names(perm)
    perm <- Rle(as.numeric(names(perm)),perm)
    minpv <- 1/length(perm)
    rm(covfwdp,covrevp,start,end,regionrcspp,rcp1,rcp2,rcp3,rcp4,
        rcfwdp,rcrevp,gcw1,gcw2,gcw3,esl,regionrcsp,perm)
    ### refine peak pvalues
    cat('...... reporting new p-value \n')
    newes <- max(esrlt)
    pvsn <- as.numeric(names(pvs))
    pvsni <- sapply(newes,function(x) sum(pvsn<=x))
    pvsni[pvsni==0] <- NA
    newpv <- pvs[pvsni]
    newpv[newes<min(pvsn)] <- 1
    newpv[newpv==0] <- minpv
    mcols(peaks) <- data.frame(mcols(peaks),newes=newes,newpv=newpv)
    peaks <- shift(resize(peaks,width(peaks)-bdw),halfbdw)
    peaks
}

#' @title CATplot of Peaks
#'
#' @description
#' Plot the consistancy between two peak lists by their significance.
#'
#' @param x A GRanges of identified peaks from one method or one replicate.
#' At least one meta column should be included to allow for significance
#' ranking of peaks.
#'
#' @param y A GRanges of identified peaks from compared method or
#' anoter replicate. At least one meta column should be included to
#' allow for significance ranking of peaks.
#'
#' @param ranks A non-negative integer vector specifying the ranks to
#' be used for CAT plot.
#'
#' @param exclude A GRanges object specifying regions to be excluded for
#' CAT plot, such as the blacklist regions proposed by ENCODE Consortium.
#'
#' @param seqinfo A vector of chromosome names to limit the CAT plot to
#' selected chromosomes. Chromosome names here must be in the same format
#' as \code{seqnames} in \code{x} and \code{y}. This parameter also helps
#' exclude uncommon chromosomes, e.g. using value
#' \code{paste0('chr',c(1:22,'X','Y'))} for human genome. Default: NULL
#' means no limit to chromosomes.
#'
#' @param esx A non-negative integer specifying which meta column of
#' \code{x} to be used to rank peak significance. Larger values in this
#' column should indicate higher significance.
#'
#' @param esy A non-negative integer specifying which meta column of
#' \code{y} to be used to rank peak significance. Larger values in this
#' column should indicate higher significance.
#'
#' @param add A logical vector which, when TRUE, adds the current plotting
#' line to existing plots. FALSE will generate a new plot.
#'
#' @param ... Other parameters passed to \code{plot} or \code{lines}.
#'
#' @return A CAT plot.
#'
#' @import S4Vectors
#' @import GenomicRanges
#' @importFrom graphics plot
#' @importFrom graphics lines
#'
#' @export
#' @examples
#' bam <- system.file("extdata", "chipseq.bam", package="gcapc")
#' cov <- read5endCoverage(bam)
#' bdw <- bindWidth(cov)
#' gcb1 <- gcEffects(cov, bdw, sampling=c(0.15,1), plot=FALSE)
#' peaks1 <- gcapcPeaks(cov, gcb1, bdw)
#' gcb2 <- gcEffects(cov, bdw, sampling=c(0.2,1), plot=FALSE)
#' peaks2 <- gcapcPeaks(cov, gcb2, bdw)
#' peaksCAT(peaks1, peaks2, ranks=seq(100,200,5), ylim=c(0,1))

peaksCAT <- function(x,y,ranks=seq(200,min(length(x),length(y),20000),50),
                     exclude=GRanges(),seqinfo=NULL,
                     esx=1,esy=1,add=FALSE,...){
    if(!is.null(seqinfo)) {
        seqlevels(x,pruning.mode="coarse") <- seqinfo
        seqlevels(y,pruning.mode="coarse") <- seqinfo
        ranks <- ranks[ranks <= min(length(x),length(y))]
    }
    if(length(exclude)>=1){
        fox <- findOverlaps(x,exclude)
        foy <- findOverlaps(y,exclude)
        x <- x[setdiff(seq_along(x),queryHits(fox))]
        y <- y[setdiff(seq_along(y),queryHits(foy))]
        ranks <- ranks[ranks <= min(length(x),length(y))]
    }
    fo <- findOverlaps(x,y)
    xfo <- queryHits(fo)
    yfo <- subjectHits(fo)
    xo <- order(mcols(x)[,esx],decreasing=TRUE)
    yo <- order(mcols(y)[,esy],decreasing=TRUE)
    xycat <- sapply(ranks,function(t){
        idx <- seq_len(t)
        sum(xfo %in% xo[idx] & yfo %in% yo[idx])/t
    })
    if(add) lines(ranks,xycat,...)
    else plot(ranks,xycat,type='l',...)
}

#' @title GC Effects Aware Peak Calling
#'
#' @description
#' This function calls ChIP-seq peaks using potential GC effects information.
#' Enrichment scores are calculated on sliding windows of prefiltered
#' large regions, with GC effects considered. Permutation analysis is
#' used to determine significant binding peaks.
#'
#' @param coverage A list object returned by function \code{read5endCoverage}.
#'
#' @param gcbias A list object returned by function \code{gcEffects}.
#'
#' @param bdwidth A non-negative integer vector with two elements
#' specifying ChIP-seq binding width and peak detection half window size.
#' Usually generated by function \code{bindWidth}. A bad estimation of
#' bdwidth results no meaning of downstream analysis. The values
#' need to be the same as it is when calculating \code{gcbias}. 
#'
#' @param flank A non-negative integer specifying the flanking width of
#' ChIP-seq binding. This parameter provides the flexibility that reads
#' appear in flankings by decreased probabilities as increased distance
#' from binding region. This paramter helps to define effective GC
#' content calculation. Default is NULL, which means this paramater will
#' be calculated from \code{bdwidth}. However, if customized numbers
#' provided, there won't be recalucation for this parameter; instead, the
#' 2nd elements of \code{bdwidth} will be recalculated based on \code{flank}.
#' The value needs to be the same as it is when calculating \code{gcbias}.
#'
#' @param prefilter A non-negative integer specifying the minimum of reads
#' to qualify a potential binding region. Regions with total of reads from
#' forward and reverse strands larger or equivalent to \code{prefilter} are
#' selected for downstream analysis. Default is 4.
#'
#' @param permute A non-negative integer specifying times of permutation to
#' be performed. Default is 5. When whole large genome is used, such as
#' human genome, 5 times of permutation could be enough.
#'
#' @param pv A numeric specifying p-value cutoff for significant
#' binding peaks. Default is 0.05.
#'
#' @param plot A logical vector which, when TRUE (default), returns density
#' plots of real and permutation enrichment scores.
#'
#' @param genome A \link[BSgenome]{BSgenome} object containing the sequences
#' of the reference genome that was used to align the reads, or the name of
#' this reference genome specified in a way that is accepted by the
#' \code{\link[BSgenome]{getBSgenome}} function defined in the \pkg{BSgenome}
#' software package. In that case the corresponding BSgenome data package
#' needs to be already installed (see \code{?\link[BSgenome]{getBSgenome}} in
#' the \pkg{BSgenome} package for the details). The value needs to be the same
#' as it is when calculating \code{gcbias}.
#'
#' @param gctype A character vector specifying choice of method to calculate
#' effective GC content. Default \code{ladder} is based on uniformed fragment
#' distribution. A more smoother method based on tricube assumption is also
#' allowed. However, tricube should be not used if estimated peak half size
#' is 3 times or more larger than estimated bind width. The value
#' needs to be the same as it is when calculating \code{gcbias}.
#'
#' @return A GRanges of peaks with meta columns:
#' \item{es}{Estimated enrichment score.}
#' \item{pv}{p-value.}
#'
#' @import S4Vectors
#' @import IRanges
#' @import GenomicRanges
#' @import Biostrings
#' @importFrom BSgenome getBSgenome
#' @importFrom BSgenome getSeq
#' @importFrom stats density
#' @importFrom graphics plot
#' @importFrom graphics lines
#' @importFrom graphics abline
#' @importFrom graphics legend
#' @importFrom methods as
#'
#' @export
#' @examples
#' bam <- system.file("extdata", "chipseq.bam", package="gcapc")
#' cov <- read5endCoverage(bam)
#' bdw <- bindWidth(cov)
#' gcb <- gcEffects(cov, bdw, sampling = c(0.15,1))
#' gcapcPeaks(cov, gcb, bdw)

gcapcPeaks <- function(coverage,gcbias,bdwidth,flank=NULL,prefilter=4L,
                       permute=5L,pv=0.05,plot=FALSE,genome="hg19",
                       gctype=c("ladder","tricube")){
    genome <- getBSgenome(genome)
    gctype <- match.arg(gctype)
    bdw <- bdwidth[1]
    halfbdw <- floor(bdw/2)
    if(is.null(flank)){
        pdwh <- bdwidth[2]
        flank <- pdwh-bdw+halfbdw
    }else{
        pdwh <- flank+bdw-halfbdw
    }
    if(gctype=="ladder"){
      weight <- c(seq_len(flank),rep(flank+1,bdw),rev(seq_len(flank)))
      weight <- weight/sum(weight)
    }else if(gctype=="tricube"){
      w <- flank+halfbdw
      weight <- (1-abs(seq(-w,w)/w)^3)^3
      weight <- weight/sum(weight)
    }
    cat("Starting to call peaks.\n")
    ### prefiltering regions
    cat("...... prefiltering regions\n")
    seqs <- sapply(coverage$fwd,length)
    seqs <- floor(seqs/bdw-10)*bdw
    starts <- lapply(seqs, function(i) seq(1+bdw*10, i, bdw))
    ends <- lapply(seqs, function(i) seq(bdw*11, i, bdw))
    chrs <- rep(names(seqs), times=sapply(starts, length))
    region <- GRanges(chrs, IRanges(start=unlist(starts),end=unlist(ends)))
    regionsp <- resize(split(region,seqnames(region)),pdwh)
    rcfwd <- unlist(viewSums(Views(coverage$fwd,
                 ranges(shift(regionsp,-flank)))))
    rcrev <- unlist(viewSums(Views(coverage$rev,
                 ranges(shift(regionsp,halfbdw)))))
    regions <- region[rcfwd+rcrev >= prefilter]
    rm(seqs,starts,ends,chrs,region,regionsp,rcfwd,rcrev)
    ## extend both ends
    regionsrc <- reduce(shift(resize(regions,halfbdw*6+flank*2+1),
                              -halfbdw*2-flank))
    regionsgc <- shift(resize(regionsrc,width(regionsrc)+halfbdw*2),-halfbdw)
    rm(regions)
    ### gc content
    cat("...... caculating GC content\n")
    nr <- shift(resize(regionsgc,width(regionsgc)+flank*2),-flank)
    seqs <- getSeq(genome,nr)
    gcpos <- startIndex(vmatchPattern("S", seqs, fixed="subject"))
    gcposb <- vector("integer",sum(as.numeric(width(nr))))
    gcposbi <- rep(seq_along(nr),times=width(nr))
    gcposbsp <- split(gcposb,gcposbi)
    for(i in seq_along(nr)){
        gcposbsp[[i]][gcpos[[i]]] <- 1L
    }
    gcposbsprle <- as(gcposbsp,"RleList")
    gcnuml <- width(regionsgc)-halfbdw*2
    gcnum <- vector('numeric',sum(as.numeric(gcnuml)))
    gcnumi <- rep(seq_along(nr),times=gcnuml)
    gc <- split(gcnum,gcnumi)
    for(i in seq_along(nr)){
        gc[[i]] <- round(runwtsum(gcposbsprle[[i]],k=length(weight),
                       wt=weight),3)
        if(i%%500 == 0) cat('.')
    }
    cat('\n')
    rm(regionsgc,nr,seqs,gcpos,gcposb,gcposbi,
        gcposbsp,gcposbsprle,gcnuml,gcnum,gcnumi)
    ### gc weight
    cat("...... caculating GC effect weights\n")
    gcwbase0 <- round(Rle(gcbias$mu0med1/gcbias$mu0),3)
    gcw <- RleList(lapply(gc,function(x) gcwbase0[x*1000+1])) # slow
    rm(gc,gcwbase0)
    ### reads count
    regionrcsp <- split(regionsrc,seqnames(regionsrc))
    rcfwd <- RleList(unlist(viewApply(Views(coverage$fwd,ranges(regionrcsp)),
                 runsum,k=pdwh)))
    rcrev <- RleList(unlist(viewApply(Views(coverage$rev,ranges(regionrcsp)),
                 runsum,k=pdwh)))
    ### enrichment score
    cat("...... estimating enrichment score\n")
    esl <- width(regionsrc)-halfbdw*2-flank*2
    ir1 <- IRangesList(start=IntegerList(as.list(rep(1,length(esl)))),
               end=IntegerList(as.list(esl)))
    ir2 <- IRangesList(start=IntegerList(as.list(rep(1+halfbdw+flank,
               length(esl)))),end=halfbdw+flank+IntegerList(as.list(esl)))
    ir3 <- IRangesList(start=IntegerList(as.list(rep(1+halfbdw*2+flank*2,
               length(esl)))),
               end=halfbdw*2+flank*2+IntegerList(as.list(esl)))
    rc1 <- rcfwd[ir1]
    rc2 <- rcfwd[ir2]
    rc3 <- rcrev[ir1]
    rc4 <- rcrev[ir2]
    gcw1 <- gcw[ir2]
    gcw2 <- gcw[ir3]
    gcw3 <- gcw[ir1]
    esrlt <- round(2*sqrt(rc1*rc4)*gcw1-rc3*gcw3-rc2*gcw2,3)
    names(esrlt) <- seq_along(regionsrc)
    rm(rcfwd,rcrev,gcw,rc1,rc2,rc3,rc4)
    ### permutation analysis
    cat("...... permutation analysis\n")
    perm <- table(c())
    for(p in seq_len(permute)){
        covfwdp <- coverage$fwd[ranges(regionrcsp)]
        covrevp <- coverage$rev[ranges(regionrcsp)]
        for(i in seq_along(coverage$fwd)){
            covfwdp[[i]] <- covfwdp[[i]][sample.int(length(covfwdp[[i]]))]
            covrevp[[i]] <- covrevp[[i]][sample.int(length(covrevp[[i]]))]
        }
        end <- cumsum(width(regionrcsp))
        start <- end-width(regionrcsp)+1
        regionrcspp <- IRangesList(start=start,end=end)
        rcfwdp <- RleList(unlist(viewApply(Views(covfwdp,regionrcspp),
                                         runsum,k=pdwh)))
        rcrevp <- RleList(unlist(viewApply(Views(covrevp,regionrcspp),
                                         runsum,k=pdwh)))
        rcp1 <- rcfwdp[ir1]
        rcp2 <- rcfwdp[ir2]
        rcp3 <- rcrevp[ir1]
        rcp4 <- rcrevp[ir2]
        accum <- table(unlist(round(2*sqrt(rcp1*rcp4)*gcw1-rcp3*gcw3-
                                    rcp2*gcw2,3),use.names=FALSE))
        n <- intersect(names(perm), names(accum))
        perm <- c(perm[!(names(perm) %in% n)],
                 accum[!(names(accum) %in% n)],
                 perm[n] + accum[n])
        cat('......... permutation',p,'\n')
    }
    perm <- perm[order(as.numeric(names(perm)))]
    pvs <- 1- cumsum(as.numeric(perm))/sum(as.numeric(perm))
    names(pvs) <- names(perm)
    perm <- Rle(as.numeric(names(perm)),perm)
    rm(covfwdp,covrevp,start,end,regionrcspp,rcp1,rcp2,rcp3,rcp4,
        rcfwdp,rcrevp,gcw1,gcw2,gcw3,esl,regionrcsp)
    ### report peaks
    cat('...... reporting peaks\n')
    sccut <- quantile(perm,1-pv)
    minpv <- 1/length(perm)
    cat('......... enrichment scores cut at',sccut,'\n')
    if(plot){
        cat('......... ploting enrichment scores\n')
        es <- as.numeric(unlist(esrlt,use.names=FALSE))
        perm <- as.numeric(perm)
        plot(density(perm,bw=1),col='blue',xlab='enrichment score',
            xlim=range(es),main=paste('es determined by pvalue',pv))
        lines(density(es,bw=1),col='red')
        abline(v=sccut,lty=2,col='purple')
        legend('topright',c('real','perm'),lty=1,
            col=c('red','blue'),bty='n')
        rm(es)
    }
    rm(perm)
    cat('......... reporting peak bumps\n')
    esrltsl <- slice(esrlt,sccut,rangesOnly=TRUE)
    esrltsl0 <- slice(esrlt,0,rangesOnly=TRUE)
    esrltsle <- reduce(shift(resize(esrltsl,width(esrltsl)+halfbdw*2),
                    -halfbdw))
    peaksir <- intersect(esrltsl0,esrltsle)
    peaksir <- peaksir[width(peaksir)>=halfbdw]
    rm(esrltsl,esrltsl0,esrltsle)
    cat('......... summarizing peak score and pvalue\n')
    peaksir <- unlist(peaksir)
    regionids <- as.integer(names(peaksir))
    peaksirlst <- IRangesList(start=IntegerList(as.list(start(peaksir))),
                      end=IntegerList(as.list(end(peaksir))))
    if(length(regionids)>50000){
        stepa <- seq(1,length(regionids),50000)
        stepb <- seq(50000,length(regionids),50000)
        if(length(stepb)+1 == length(stepa))
            stepb <- c(stepb,length(regionids))
        peaksc <- c()
        for(i in seq_along(stepa)){
            idx <- stepa[i]:stepb[i]
            peaksc <- c(peaksc,max(esrlt[regionids[idx]][peaksirlst[idx]]))
        }
    }else{
        peaksc <- max(esrlt[regionids][peaksirlst])
    }
    peaksir <- shift(peaksir,start(regionsrc)[regionids]+halfbdw+flank)
    peaks <- GRanges(seqnames(regionsrc)[regionids],peaksir,es=peaksc)
    peaksrd <- reduce(peaks,min.gapwidth=halfbdw,with.revmap=TRUE)
    peaksrd$es <- sapply(peaksrd$revmap,function(i) max(peaks$es[i]))
    peaksrd$revmap <- NULL
    pvsn <- as.numeric(names(pvs))
    pvsni <- sapply(peaksrd$es,function(x) sum(pvsn<=x))
    pvsni[pvsni==0] <- NA
    peaksrd$pv <- pvs[pvsni]
    peaksrd$pv[peaksrd$es<min(pvsn)] <- 1
    peaksrd$pv[peaksrd$pv==0] <- minpv
    peaksrd
}

#' @title ChIP-seq GC Effects Estimation
#'
#' @description
#' GC effects are estimated based on effective GC content and reads count
#' on genome-wide windows, using generalized linear mixture models. Genome
#' wide windows are randomly or supervised sampled with given proportions.
#' GC effects of background and foreground are estimated separately.
#'
#' @param coverage A list object returned by function \code{read5endCoverage}.
#'
#' @param bdwidth A non-negative integer vector with two elements
#' specifying ChIP-seq binding width and peak detection half window size.
#' Usually generated by function \code{bindWidth}. A bad estimation of
#' bdwidth results no meaning of downstream analysis.
#'
#' @param flank A non-negative integer specifying the flanking width of
#' ChIP-seq binding. This parameter provides the flexibility that reads
#' appear in flankings by decreased probabilities as increased distance
#' from binding region. This paramter helps to define effective GC
#' content calculation. Default is NULL, which means this paramater will
#' be calculated from \code{bdwidth}. However, if customized numbers
#' provided, there won't be recalucation for this parameter; instead, the
#' 2nd elements of \code{bdwidth} will be recalculated based on \code{flank}.
#'
#' @param plot A logical vector which, when TRUE (default), returns plots
#' of intermediate results.
#'
#' @param sampling A numeric vector with length 2. The first number specifies
#' the proportion of regions to be sampled for GC effects estimation.
#' The second number specifies the repeat times for sampling.
#' Default c(0.05,1) gives pretty robust estimation for human genome. However,
#' smaller genomes might need both higher proportion and more repeat times for
#' robust estimation.
#'
#' @param supervise A GRanges object specifying peak regions in the
#' studied data, such as peaks called by peak callers, e.g. MACS & SPP. These
#' peak regions provide supervised window sampling for both mixtures in the
#' generalized linear model. Default no supervising. Or, if provided peak
#' regions have too few covered windows, supervised sampling will be replaced
#' by random sampling automatically.
#'
#' @param gcrange A non-negative numeric vector with length 2. This vector
#' sets the range of GC content to filter regions for GC effect estimation.
#' For human, most regions have GC content between 0.3 and 0.8, which is
#' set as the default. Other regions with GC content beyond this range
#' will be ignored. This range is critical when very few foreground regions
#' are selected for mixture model fitting, since outliers could drive the
#' regression lines. Thus, if possible, first make a scatter plot between
#' counts and GC content to decide  this parameter. Alternatively,
#' select a narrower range, e.g. c(0.35,0.7), to aviod outlier effects from
#' both high and low GC-content regions.
#'
#' @param emtrace A logical vector which, when TRUE (default), allows to
#' print the trace of log likelihood changes in EM iterations.
#'
#' @param model A character specifying the distribution model to be used in
#' generalized linear model fitting. The default is negative
#' binomial(\code{nbinom}), while \code{poisson} is also supported currently.
#' Based on our tests of multiple datasets, mostly poisson is a very good
#' approximation of negative binomial, and provides much faster model fitting.
#'
#' @param mu0 A non-negative numeric initiating read count signals for
#' background regions. This is treated as the starting value of background mean
#' for poisson/nbinom fitting. Default is 1.
#'
#' @param mu1 A non-negative numeric initiating read count signals for
#' foreground regions. This is treated as the starting value of foreground mean
#' for poisson/nbinom fitting, Default is 50.
#'
#' @param theta0 A non-negative numeric initiating the shape parameter of
#' negative binomial model for background regions. For more detail, see
#' theta in \code{\link[MASS]{glm.nb}} function.
#'
#' @param theta1 A non-negative numeric initiating the shape parameter of
#' negative binomial model for foreground regions. For more detail, see
#' theta in \code{\link[MASS]{glm.nb}} function.
#'
#' @param p A non-negative numeric specifying the proportion of foreground
#' regions in all estimated regions. This is treated as a starting value for
#' EM algorithm. Default is 0.02.
#'
#' @param converge A non-negative numeric specifying the condition of EM
#' algorithm termination. EM algorithm stops when the ratio of log likelihood
#' increment to whole log likelihood is less or equivalent to
#' \code{converge}.
#'
#' @param genome A \link[BSgenome]{BSgenome} object containing the sequences
#' of the reference genome that was used to align the reads, or the name of
#' this reference genome specified in a way that is accepted by the
#' \code{\link[BSgenome]{getBSgenome}} function defined in the \pkg{BSgenome}
#' software package. In that case the corresponding BSgenome data package
#' needs to be already installed (see \code{?\link[BSgenome]{getBSgenome}} in
#' the \pkg{BSgenome} package for the details).
#'
#' @param gctype A character vector specifying choice of method to calculate
#' effective GC content. Default \code{ladder} is based on uniformed fragment
#' distribution. A more smoother method based on tricube assumption is also
#' allowed. However, tricube should be not used if estimated peak half size
#' is 3 times or more larger than estimated bind width.
#'
#' @return A list of objects
#' \item{gc}{The GC contents at which GC effects are estimated.}
#' \item{mu0}{Predicted background signals at GC content \code{gc}.}
#' \item{mu1}{Predicted foreground signals at GC content \code{gc} .}
#' \item{mu0med0}{Median of predicted background signals.}
#' \item{mu1med1}{Median of predicted foreground signals.}
#' \item{mu0med1}{Median of predicted background signals at GC content of
#' foreground windows.}
#' \item{mu1med0}{Median of predicted foreground signals at GC content of
#' background windows.}
#'
#' @import S4Vectors
#' @import IRanges
#' @import GenomicRanges
#' @import Biostrings
#' @import MASS
#' @importFrom BSgenome getBSgenome
#' @importFrom BSgenome getSeq
#' @importFrom splines ns
#' @importFrom grDevices colorRampPalette
#' @importFrom graphics layout
#' @importFrom graphics plot
#' @importFrom graphics axis
#' @importFrom graphics lines
#' @importFrom stats dpois
#' @importFrom stats dnbinom
#' @importFrom stats glm
#' @importFrom stats predict
#'
#' @export
#' @examples
#' bam <- system.file("extdata", "chipseq.bam", package="gcapc")
#' cov <- read5endCoverage(bam)
#' bdw <- bindWidth(cov)
#' gcb <- gcEffects(cov, bdw, sampling = c(0.15,1))

gcEffects <- function(coverage,bdwidth,flank=NULL,plot=TRUE,
                      sampling=c(0.05,1),supervise=GRanges(),
                      gcrange=c(0.3,0.8),emtrace=TRUE,
                      model=c('nbinom','poisson'),
                      mu0=1,mu1=50,theta0=mu0,theta1=mu1,
                      p=0.02,converge=1e-3,
                      genome="hg19",gctype=c("ladder","tricube")){
    ### input sanity check
    genome <- getBSgenome(genome)
    model <- match.arg(model)
    gctype <- match.arg(gctype)
    bdw <- bdwidth[1]
    halfbdw <- floor(bdw/2)
    if((length(bdwidth)<2 & is.null(flank)) ||
       (!is.null(flank) & length(bdwidth)<1))
        stop("Parameter 'bdwidth' or 'flank' error.\n")
    if(is.null(flank)){
        pdwh <- bdwidth[2]
        flank <- pdwh-bdw+halfbdw
    }else{
        pdwh <- flank+bdw-halfbdw
    }
    if(length(sampling)<2 || sampling[1]<=0 || sampling[1]>1 || sampling[2]<1)
        stop("Parameter 'sampling' error.\n")
    sampling[2] <- floor(sampling[2])
    if(class(supervise)!="GRanges")
        stop("Parameter 'supervise' error.\n")
    if(sum(gcrange<0)>0 || sum(gcrange>1)>0 || sum(is.na(gcrange))>0)
        stop("Parameter 'gcrange' error.\n")
    if(mu0<=0 || mu1<=0 || mu0>=mu1)
        stop("Parameter 'mu0' or 'mu1' error.\n")
    if(model=='nbinom' && (theta1<=0 || theta0<=0))
        stop("Parameter 'theta0' or 'theta1' error in nbinom model.\n")
    if(p<=0 || p>=0.5)
        stop("'p' must be in (0,0.5).\n")
    if(converge<=0 || converge>0.1)
        stop("'converge' must be in (0,0.1].\n")
    if(gctype=="ladder"){
        weight <- c(seq_len(flank),rep(flank+1,bdw),rev(seq_len(flank)))
        weight <- weight/sum(weight)
    }else if(gctype=="tricube"){
        w <- flank+halfbdw
        weight <- (1-abs(seq(-w,w)/w)^3)^3
        weight <- weight/sum(weight)
    }
    ### regions
    cat("Starting to estimate GC effects\n")
    seqs <- sapply(coverage$fwd,length)
    seqs <- floor(seqs/bdw-10)*bdw
    binl <- sapply(seqs, function(i) length(seq(1+bdw*10, i, bdw)))
    starts <- unlist(lapply(seqs, function(i) seq(1+bdw*10, i, bdw)))
    ends <- unlist(lapply(seqs, function(i) seq(bdw*11, i, bdw)))
    chrs <- rep(names(seqs), times=binl)
    region <- GRanges(chrs,IRanges(start=starts,end=ends))
    rm(seqs,binl,starts,ends,chrs)
    ###  sampling and counts
    fo <- unique(subjectHits(findOverlaps(supervise,region)))
    if(length(fo)<1000 || length(region)-length(fo) <1000){
        cat("...... Too few/much ranges in 'supervise'.",
            "Selecting random sampling\n")
        sampidx <- sort(as.integer(sapply(seq_len(sampling[2]),function(x)
               sample.int(length(region),floor(length(region)*sampling[1])))))
        samptype <- 'random'

    }else{
        cat("...... Selecting supervised sampling\n")
        num1 <- floor(length(fo) * sampling[1])
        num2 <- floor((length(region)-length(fo)) * sampling[1])
        num1 <- min(num1*ceiling(0.1/(num1/num2)),length(fo))
        sampidx <- sort(as.integer(sapply(seq_len(sampling[2]),
                   function(x) c(sample(fo,num1),
                   sample(setdiff(seq_along(region),fo),num2)))))
        samptype <- 'supervised'
    }
    region <- region[sampidx]
    cat("......... Sampling",sampling[1]*100,"percent of regions by",
        sampling[2], "times, total",length(region),"regions\n")
    regionsp <- resize(split(region,seqnames(region)),pdwh)
    cat("...... Counting reads\n")
    rcfwd <- unlist(viewSums(Views(coverage$fwd,
                                   ranges(shift(regionsp,-flank)))))
    rcrev <- unlist(viewSums(Views(coverage$rev,
                                   ranges(shift(regionsp,halfbdw)))))
    rm(regionsp,sampidx,fo)
    if(plot){
        idxx <- sample.int(length(region),min(50000,length(region)))
        plot(rcfwd[idxx],rcrev[idxx],
             main=paste('RC: shifted',halfbdw,"; CORR:",
                 round(cor(rcfwd,rcrev),3),"; Flank:",flank),
             ylab='Reverse strand',xlab='Forward strand')
        rm(idxx)
    }
    ### effective gc content
    cat("...... Calculating GC content with flanking",flank,"\n")
    rwidth <- width(region[1])
    nr <- shift(resize(region,rwidth + flank*2),-flank)
    seqs <- getSeq(genome,nr) # slow
    gcpos <- startIndex(vmatchPattern("S", seqs, fixed="subject"))
    gc <- round(sapply(gcpos,function(x) sum(weight[x])),3)
    rm(rwidth,nr,seqs,gcpos,region)
    ### em algorithms
    cat("...... Estimating GC effects\n")
    gc <- rep(gc,2)
    rc <- c(rcfwd,rcrev)
    idx <- gc>=gcrange[1] & gc<=gcrange[2] & !is.na(rc) & !is.na(gc)
    dat <- data.frame(y=rc[idx],gc=gc[idx])
    if(model=='poisson'){
        logp1 <- dpois(dat$y, lambda = mu1, log = TRUE)
        logp0 <- dpois(dat$y, lambda = mu0, log = TRUE)
    }else{
        logp1 <- dnbinom(dat$y, size=theta1, mu=mu1, log = TRUE)
        logp0 <- dnbinom(dat$y, size=theta0, mu=mu0, log = TRUE)
    }
    z <- 1/(1+exp(logp0-logp1)*(1-p)/p)
    llf <- sum(z*(logp1+log(p)) + (1-z)*(logp0+log(1-p)))
    llgap <- llf
    i <- 0
    rm(rcfwd,rcrev,rc,gc,idx)
    while(abs(llgap) > (abs(llf) * converge) && i < 100){
        p <- (2+sum(z))/(2*2+length(z))
        dat1 <- dat[z>=0.5,]
        dat0 <- dat[z<0.5,]
        if(model=='poisson'){
            lmns0 <- glm(y ~ ns(gc, df = 2), data=dat0, family="poisson")
            lmns1 <- glm(y ~ ns(gc, df = 2), data=dat1, family="poisson")
            predY0 <- predict(lmns0, data.frame(gc = dat$gc),type="response")
            predY1 <- predict(lmns1, data.frame(gc = dat$gc),type="response")
            logp1 <- dpois(dat$y, lambda = predY1, log = TRUE)
            logp0 <- dpois(dat$y, lambda = predY0, log = TRUE)
        }else{
            # slow
            lmns0 <- glm.nb(y ~ ns(gc, df = 2), data=dat0, init.theta=theta0)
            lmns1 <- glm.nb(y ~ ns(gc, df = 2), data=dat1, init.theta=theta1)
            predY0 <- predict(lmns0, data.frame(gc = dat$gc),type="response")
            predY1 <- predict(lmns1, data.frame(gc = dat$gc),type="response")
            theta1 <- lmns1$theta
            theta0 <- lmns0$theta
            logp1 <- dnbinom(dat$y, size=theta1, mu=predY1, log = TRUE)
            logp0 <- dnbinom(dat$y, size=theta0, mu=predY0, log = TRUE)
        }
        z <- 1/(1+exp(logp0-logp1)*(1-p)/p)
        if(sum(z>=0.5) < length(gc)*0.0005 | sum(z<0.5) < length(gc)*0.0005)
            break;
        lli <- sum(z*(logp1+log(p)) + (1-z)*(logp0+log(1-p)))
        llgap <- lli - llf
        llf <- lli
        i <- i + 1
        if(emtrace)
            cat("......... Iteration",i,'\tll',llf,'\tincrement',llgap,'\n')
    }
    ### gc effects
    gcbase <- round(seq(0,1,0.001),3)
    gcbias <- list(gc=gcbase,
                   mu0=predict(lmns0,data.frame(gc = gcbase),type="response"),
                   mu1=predict(lmns1,data.frame(gc = gcbase),type="response"),
                   mu0med0=median(predY0[z<0.5]),
                   mu1med1=median(predY1[z>=0.5]),
                   mu0med1=median(predY0[z>=0.5]),
                   mu1med0=median(predY1[z<0.5]))
    if(plot){
        tmp <- nrow(dat)
        idx0 <- sample.int(tmp,min(100000,tmp))
        rbPal <- colorRampPalette(c('green','orange'))
        color <- rbPal(20)[as.numeric(cut(z[idx0],breaks = 20))]
        plot(dat$gc[idx0],dat$y[idx0]+0.5,col=color,xlim=gcrange,pch=20,
             main=paste(model,samptype),
             xlab='Effective GC content',ylab="Read counts",log='y',yaxt='n')
        idx00 <- sample.int(tmp,min(5000,tmp))
        idx00 <- idx00[order(dat$gc[idx00])]
        lines(dat$gc[idx00],predY1[idx00]+0.5,col='red',lwd=3)
        lines(dat$gc[idx00],predY0[idx00]+0.5,col='blue',lwd=3)
        axis(side=2, at=c(0,2^(0:10))+0.5, labels=c(0,2^(0:10)))
    }
    gcbias
}

#' @title ChIP-seq Binding Width And Peak Window Size Estimation
#'
#' @description
#' ChIP-seq experiments usually use crosslinking strategy to capture
#' sequencing fragments. The fragment location is affected by at least but
#' not limited to two factors, protein real binding and crosslinking
#' operation. This function estimate size of binding part in crosslinked
#' DNA-protein complexes, and denoted that as ChIP-seq binding width.Also,
#' the peak detection window half size is estimated based on binding width.
#'
#' @param coverage A list object returned by function \code{read5endCoverage}.
#'
#' @param range A non-nagative integer vector with length 2. This vector
#' set the range within which binding width and peak window size are 
#' estimated. Default c(50,500) represents most ChIP-seq experiments.
#'
#' @param step A non-negative integer to set the resolution of binding
#' width estimation within \code{range}. This value will be tuned if
#' \code{auto} is TRUE. Default 50 is based on default value of 
#' \code{range}.
#' 
#' @param odd A logical vector which, when TRUE, only allows return odd
#' number of binding width, which is preferred by the 
#' effective GC content estimation. Default: TRUE.
#'
#' @return A numeric vector with 2 elements:
#' Estimated binding width and half size of peak detection window.
#'
#' @import S4Vectors
#' @import IRanges
#' @import GenomicRanges
#'
#' @export
#' @examples
#' bam <- system.file("extdata", "chipseq.bam", package="gcapc")
#' cov <- read5endCoverage(bam)
#' bindWidth(cov)

bindWidth <- function(coverage,range=c(50L,500L),step=50L,odd=TRUE){
    cat("Starting to estimate bdwidth.\n")
    if(!is.list(coverage) || length(coverage)!=2)
        stop("bdwidth: coverage is not a list of 2 elements\n")
    if(sum(names(coverage) %in% c("fwd","rev"))!=2)
        stop("bdwidth: names of coverage is not correct\n")
    if(length(coverage$fwd)!=length(coverage$rev))
        stop("bdwidth: chroms differ between fwd and rev strands\n")
    if(step<1) stop("bdwidth: step must be at least 1")
    step <- round(step)
    ## cross correlation estimation
    readsum <- sapply(coverage$fwd,sum) + sapply(coverage$rev,sum)
    chromlen <- sapply(coverage$fwd,length)
    cycle <- 1
    rangein <- range
    w2 <- 0
    shifts <- seq(range[1],range[2],step)
    repeat{
        cat("...... Cycle",cycle,"for bind width estimation\n")
        regionpos <- regionneg <- IRangesList()
        for(i in seq_along(coverage$fwd)){
            regionpos[[i]] <- IRanges(start=rep(1,length(shifts)),
                              end=chromlen[i]-shifts)
            regionneg[[i]] <- IRanges(start=shifts+1,
                              end=rep(chromlen[i],length(shifts)))
        }
        viewpos <- Views(coverage$fwd,regionpos)
        viewneg <- Views(coverage$rev,regionneg)
        cors <- sapply(seq_along(viewpos),function(i)
                    cor(viewpos[[i]],viewneg[[i]]))
        corsall <- colSums(t(cors) * readsum / sum(readsum))
        #if(cycle==1) plot(shifts,corsall)
        if(step>1){
            range <- shifts[which.max(corsall)]+c(-step,step)
            step <- max(round(step/5),1)
            cycle <- cycle + 1
            shifts <- seq(range[1],range[2],step)
        }else if(w2==0){
            w1 <- shifts[which.max(corsall)]
            cc <- max(corsall)
            tmp <- seq(0,rangein[2],5)
            shifts <- tmp[tmp > w1]
            cycle <- 'final'
            w2 <- 1
        }else{
            ccw <- (cc-corsall[length(corsall)])/3+corsall[length(corsall)]
            w2 <- min(max(shifts[corsall>=ccw]),w1*2,rangein[2])
            break
        }
    }
    rm(viewpos,viewneg)
    if(odd && w1%%2==0) w1 <- w1 + 1
    cat("...... Estimated bind width as",w1,"\n")
    cat("...... Estimated peak window half size as",w2,"\n")
    ### refine of peak window half size by region correlation
    cat("Refining peak window half size by region from two strands\n")
    halfbdw <- floor(w1/2)
    seqs <- sapply(coverage$fwd,length)
    seqs <- floor(seqs/w1-2)*w1
    starts <- lapply(seqs, function(i) seq(1+w1*2, i, w1))
    ends <- lapply(seqs, function(i) seq(w1*3, i, w1))
    chrs <- rep(names(seqs), times=sapply(starts, length))
    sampidx <- sort(sample.int(length(chrs),ceiling(length(chrs)*0.05)))
    region <- GRanges(chrs[sampidx], IRanges(start=unlist(starts)[sampidx],
                  end=unlist(ends)[sampidx]))
    rm(seqs,starts,ends,chrs,sampidx)
    pdwhs <- seq(w2,w1,-5)
    corr <- c()
    for(pdwh in pdwhs){
      flank <- pdwh-w1+halfbdw
      regionsp <- resize(split(region,seqnames(region)),pdwh)
      rcfwd <- unlist(viewSums(Views(coverage$fwd,
                   ranges(shift(regionsp,-flank)))))
      rcrev <- unlist(viewSums(Views(coverage$rev,
                   ranges(shift(regionsp,halfbdw)))))
      corr <- c(corr,cor(rcfwd,rcrev))
      cat('.')
    }
    #plot(pdwhs,corr)
    cat('\n')
    w2 <- pdwhs[which.max(corr)]
    cat("...... Refined peak window half size as",w2,"\n")
    c(w1,w2)
}

---
title: "The *gcapc* user's guide"
author: |
  | Mingxiang Teng <mxteng@jimmy.harvard.edu>
  | Rafael A. Irizarry <rafa@jimmy.harvard.edu>
  | Department of Biostatistics, Dana-Farber Cancer Institute &
  | Harvard T.H. Chan School of Public Health, Boston, MA, USA
date: "`r Sys.Date()`"
output:
  BiocStyle::html_document:
    toc: true
bibliography: gcapc.bib
graphics: yes
vignette: >
  %\VignetteIndexEntry{The gcapc user's guide}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignettePackage{gcapc}
  %\VignetteEncoding{UTF-8}
---

```{r para, echo = FALSE, results='hide'}
BiocStyle::markdown()
knitr::opts_chunk$set(dev="png",fig.show="hold",
               fig.width=8,fig.height=4.5,fig.align="center",
               message=FALSE,collapse=TRUE)
set.seed(1)
```

# Introduction

ChIP-seq has been widely utilized as the standard technology to detect
protein binding regions, where peak calling algorithms were developed
particularly to serve the analysis. Existing peak callers lack of power
on ranking peaks' significance due to sequencing technology might undergo
sequence context biases, *e.g.* GC bias. *gcapc* is designed to address this
deficiency by modeling GC effects into peak calling. *gcapc* can also help
refine the significance of peaks called by other peak callers, or correct
the GC-content bias for a read count table for a predefined set of genomic
regions across a series of samples. The *gcapc* package requires the
inputs as one ChIP-seq BAM file (for peak calling/refining) or a read
count table (for GC effects removal) as well as other optional parameters.

A common analysis for peak calling/refining contains four steps.

  1. Reads coverage. In this step, BAM file records will be converted to
  coverages on basepair resolution for forward and reverse strands
  separately.

  1. Binding width estimation. This parameter is a measurement for the size
  of protein binding region in crosslinked complexes of ChIP experiments.
  Also, peak detection half size are estimated based on region signals from
  two strands.

  1. GC effects estimation. Generalized linear mixture models followed by EM
  algorithms are performed to evaluate potential GC effects.

  1. Peak calling/refining. For peak calling, enrichment scores are
  evaluated by permutation analysis for significance. Peaks are reported
  with enrichment scores and p-values. For peak refining, peaks called by
  other peak callers should be provided as a GRanges object. New enrichment
  significances are added as meta columns for the input peaks.

For correcting GC effects on a count table, one step analysis based on
function *refineSites* is enough.

# Getting Started

Load the package in R

```{r library}
library(gcapc)
```

# Preparing Inputs

Preparing inputs for correcting GC effects on a count table should be easy by
referring to the function man page. Here, we focus on inputs for peak calling
and refining. The inputs could be as minimum as a path to a BAM file, which is
an indexed alignment records for sequencing reads. However, additional
options are encouraged to be specified to accelerate the analysis and
improve the accuracy. The following set are the options which can be
customized by users.

  1. BAM records filtering options. In the function *read5endCoverage*,
  reads can be filtered for selected chromosomes, mapping quality,
  duplicate removal, etc. Downstream analysis could be highly accelerated
  if only a subset of chromosomes are analyzed. This actually suggests
  a divide and conquer strategy if one ChIP-seq experiment is extremely
  deeply sequenced. In that case, analysis based on each chromosome
  level could save lots of memory.

  1. Sequencing fragments options. If one has prior knowledge on the
  size of sequencing fragments. The optional arguments in function
  *bindWidth* could be specified to limit searching in narrower
  ranges; Or, this function can be omitted if binding width are known
  in advance. Note that this binding width might not be equivalent to
  the binding width of protein in biology, since it could be affected
  by crosslinking operations.

  1. Sampling size for GC effects estimation. The default is 0.05, which
  means 5% of genome will be used if analysis is based on whole genome.
  However, for smaller genomes or small subset of chromosomes, this size
  should be tuned higher to ensure accuracy. Or, sample genome multiple
  times, and use average estimation to aviod sampling bias. Note: larger
  sample size or more sampling times result longer computation of
  GC effects estimation.

  1. GC ranges for GC effects estimation. As illustrated in the man pages,
  GC ranges (*gcrange* parameter) should be carefully selected. The reason
  is that regions with extremely low/high GC content sometimes act as
  outliers, and can drive the regression lines when selected forground
  regions are too few in mixture model fitting. This happens when
  the studied binding protein has too few genome-wide binding events.

  1. EM algorithm priors and convergence. Options for EM algorithms can
  be tuned to accelerate the iterations.

  1. Permutation times. As we suggested in the function help page, a
  proper times of permutation could save time as well as ensuring accuracy.

In this vignette, we will use enbedded file *chipseq.bam* as one example
to illustrate this package. This file contains about ~80000 reads from
human chromosome 21 for CTCF ChIP-seq data.

```{r data}
bam <- system.file("extdata", "chipseq.bam", package="gcapc")
```

# Peak Calling/Refining

For details of the algorithms, please refer to our paper [@teng].

## Reads coverage

The first step is to generate the reads coverage for both forward and reverse
strands. The coverage is based on single nucleotide resolution and uses only
the 5' ends of BAM records. That means, if duplicates are not allowed, the
maximum coverage for every nucleotide is 1.

```{r rc5end}
cov <- read5endCoverage(bam)
cov
```

Obejct *cov* is a two-element list representing coverages for forward and
reverse strands, respectively, while each element is a list for coverages
on individual chromosomes.

## Binding width

The second step is to estimate the binding width and peak detection half
window size of ChIP-seq experiment.
This step could be omitted if binding width is known in advance. Binding
width is further treated as the size of region unit for effective GC
bias estimation and peak calling. Peak detection half
window size is used to define width of flanking regions.

If additional information is known from sequencing fragments, this step
could be speeded up. For example, narrowing down the range size helps.

```{r bdwidth1}
bdw <- bindWidth(cov, range=c(50L,300L), step=10L)
bdw
```

## GC effects

This step performs GC effects estimation using the proposed models. It is
noted that by allowing to display the plots, one can view intermediate
results which provide you direct sense on your ChIP-seq data, such as the
extent of GC effects. Also, the EM algorithms iterations are enabled by
default to display the trace of log likelihood changes, and other
notification messages are printed for courtesy.

```{r gcbias}
layout(matrix(1:2,1,2))
gcb <- gcEffects(cov, bdw, sampling=c(0.25,1), plot=TRUE, model='poisson')
```

Here, 25% of windows were sampled with 1 repeat.
The left figure provides the correlation between forward and reverse
strands signals, by using the estimated binding width as region unit.
The right figure shows the raw and predicted GC effects using mixture model.

Two other options need to be noted here are *supervise* and *model*.
If *supervise* option is specified as a GRanges object, it provides a set of
potential peaks and allows more efficient sampling procedure. In detail, the
two mixtures are sampled separately from forground (signal) and background
regions. *model* option allows switching between Poisson and Negative Binomial
distribution (default) in model fitting. Theoratically, Negative Binomial
assumption is more accurate than poisson. Nevertheless, Poisson is a good
approximation to Negative Binomial for GC effect estimation here, and shows
much faster computing speed than Negative Binomial especially when the total
number of selected bins is large.

## Peak significance

This is the last step for peak calling. It uses information generated in
previous steps, calculates enrichment scores and performs permutation analysis
to propose significant peak regions. Final peaks are formated into *GRanges*
object, and meta columns are used to record significance. Additional
notification messages are also printed.

```{r gcapc, results='hide'}
layout(matrix(1:2,1,2))
peaks <- gcapcPeaks(cov, gcb, bdw, plot=TRUE, permute=100L)
peaks <- gcapcPeaks(cov, gcb, bdw, plot=TRUE, permute=50L)
```
```{r gcapcpeaks}
peaks
```
It is noted that here two tests using different number of permutation times
results almost the same cutoff on enrichment scores, which suggests small
number of permutations are allowed to save time. The left figure shows here
the cutoff on enrichment scores based on 50 times of permutations, and
right figure shows it based on 100 times of permutations. Note that we only
used chromosome 21 for illustration, thus increased permutation times
from default 5 to 50 here.

## Peak refining
In order to remove GC effects on other peak callers' outputs, this package
provides function to refine enrichment significance for given peaks.
Peaks have to be provided as a GRanges object. A flexible set of peaks are
preferred to reduce potential false negative, meaning both significant
(e.g. p<=0.05) and non-significant (e.g. p>0.05) peaks are preferred to be
included. If the total number of peaks is not too big, a reasonable set of
peaks include all those with p-value/FDR less than 0.99 by other peak callers.

```{r refine, results='hide', fig.width=4.5}
newpeaks <- refinePeaks(cov, gcb, bdw, peaks=peaks, permute=50L)
plot(newpeaks$es,newpeaks$newes,xlab='old score',ylab='new score')
```
```{r refinepeaks}
newpeaks
```
Here, two new meta columns are added into previous peaks (GRanges), including
adjusted significance and p-values. It is noted that the new  enrichment
scores are actually the same as previously calculated (figure above) since
the peak regions were previously called by *gcapc*. In practice, peak regions
and their significances called by other peak callers mostly would be different
from *gcapc* if there is strong GC bias. If refining those peak significances,
the improvement should be obvious as we showed in our paper.

# Correcting GC Effects for A Count Table

In this package, function *refineSites* is provided in case that some are more
interested in correcting GC effects for pre-defined regions instead of peak
calling. We used this function to adjust signals for ENCODE reported sites
in our paper [@teng]. This function is eay-to-use, with a count table and
corresponding genomic regions are the two required inputs. For detail of
using this function, please read the function man page.

# Summary

In this vignette, we went through main functions in this package, and
illustrated how they worked. By following these steps, users will be able to
remove potential GC effects either for peak identification or for read
count signals.

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/peaksCAT.r
\name{peaksCAT}
\alias{peaksCAT}
\title{CATplot of Peaks}
\usage{
peaksCAT(x, y, ranks = seq(200, min(length(x), length(y), 20000), 50),
  exclude = GRanges(), seqinfo = NULL, esx = 1, esy = 1, add = FALSE,
  ...)
}
\arguments{
\item{x}{A GRanges of identified peaks from one method or one replicate.
At least one meta column should be included to allow for significance
ranking of peaks.}

\item{y}{A GRanges of identified peaks from compared method or
anoter replicate. At least one meta column should be included to
allow for significance ranking of peaks.}

\item{ranks}{A non-negative integer vector specifying the ranks to
be used for CAT plot.}

\item{exclude}{A GRanges object specifying regions to be excluded for
CAT plot, such as the blacklist regions proposed by ENCODE Consortium.}

\item{seqinfo}{A vector of chromosome names to limit the CAT plot to
selected chromosomes. Chromosome names here must be in the same format
as \code{seqnames} in \code{x} and \code{y}. This parameter also helps
exclude uncommon chromosomes, e.g. using value
\code{paste0('chr',c(1:22,'X','Y'))} for human genome. Default: NULL
means no limit to chromosomes.}

\item{esx}{A non-negative integer specifying which meta column of
\code{x} to be used to rank peak significance. Larger values in this
column should indicate higher significance.}

\item{esy}{A non-negative integer specifying which meta column of
\code{y} to be used to rank peak significance. Larger values in this
column should indicate higher significance.}

\item{add}{A logical vector which, when TRUE, adds the current plotting
line to existing plots. FALSE will generate a new plot.}

\item{...}{Other parameters passed to \code{plot} or \code{lines}.}
}
\value{
A CAT plot.
}
\description{
Plot the consistancy between two peak lists by their significance.
}
\examples{
bam <- system.file("extdata", "chipseq.bam", package="gcapc")
cov <- read5endCoverage(bam)
bdw <- bindWidth(cov)
gcb1 <- gcEffects(cov, bdw, sampling=c(0.15,1), plot=FALSE)
peaks1 <- gcapcPeaks(cov, gcb1, bdw)
gcb2 <- gcEffects(cov, bdw, sampling=c(0.2,1), plot=FALSE)
peaks2 <- gcapcPeaks(cov, gcb2, bdw)
peaksCAT(peaks1, peaks2, ranks=seq(100,200,5), ylim=c(0,1))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/refinePeaks.r
\name{refinePeaks}
\alias{refinePeaks}
\title{Refine Peaks with GC Effects}
\usage{
refinePeaks(coverage, gcbias, bdwidth, peaks, flank = NULL, permute = 5L,
  genome = "hg19", gctype = c("ladder", "tricube"))
}
\arguments{
\item{coverage}{A list object returned by function \code{read5endCoverage}.}

\item{gcbias}{A list object returned by function \code{gcEffects}.}

\item{bdwidth}{A non-negative integer vector with two elements
specifying ChIP-seq binding width and peak detection half window size.
Usually generated by function \code{bindWidth}. A bad estimation of
bdwidth results no meaning of downstream analysis. The values
need to be the same as it is when calculating \code{gcbias}.}

\item{peaks}{A GRanges object specifying the peaks to be refined.
A flexible set of peaks are preferred to reduce potential false
negative, meaning both significant (e.g. p<=0.05) and non-significant
(e.g. p>0.05) peaks are preferred to be included. If the total
number of peaks is not too big, a reasonable set of peaks include
all those with p-value/FDR less than 0.99 by other peak callers.}

\item{flank}{A non-negative integer specifying the flanking width of
ChIP-seq binding. This parameter provides the flexibility that reads
appear in flankings by decreased probabilities as increased distance
from binding region. This paramter helps to define effective GC
content calculation. Default is NULL, which means this paramater will
be calculated from \code{bdwidth}. However, if customized numbers
provided, there won't be recalucation for this parameter; instead, the
2nd elements of \code{bdwidth} will be recalculated based on \code{flank}.
The value needs to be the same as it is when calculating \code{gcbias}.}

\item{permute}{A non-negative integer specifying times of permutation to
be performed. Default is 5. When whole large genome is used, such as
human genome, 5 times of permutation could be enough.}

\item{genome}{A \link[BSgenome]{BSgenome} object containing the sequences
of the reference genome that was used to align the reads, or the name of
this reference genome specified in a way that is accepted by the
\code{\link[BSgenome]{getBSgenome}} function defined in the \pkg{BSgenome}
software package. In that case the corresponding BSgenome data package
needs to be already installed (see \code{?\link[BSgenome]{getBSgenome}} in
the \pkg{BSgenome} package for the details). The value needs to be the same
as it is when calculating \code{gcbias}.}

\item{gctype}{A character vector specifying choice of method to calculate
effective GC content. Default \code{ladder} is based on uniformed fragment
distribution. A more smoother method based on tricube assumption is also
allowed. However, tricube should be not used if estimated peak half size
is 3 times or more larger than estimated bind width. The value
needs to be the same as it is when calculating \code{gcbias}.}
}
\value{
A GRanges object the same as \code{peaks} with two additional
meta columns:
\item{newes}{Refined enrichment scores.}
\item{newpv}{Refined pvalues.}
}
\description{
This function refines the ranks (i.e. significance/pvalue) of
pre-determined peaks by potential GC effects. These peaks can be
obtained from other peak callers, e.g. MACS or SPP.
}
\examples{
bam <- system.file("extdata", "chipseq.bam", package="gcapc")
cov <- read5endCoverage(bam)
bdw <- bindWidth(cov)
gcb <- gcEffects(cov, bdw, sampling = c(0.15,1))
peaks <- gcapcPeaks(cov, gcb, bdw)
refinePeaks(cov, gcb, bdw, peaks)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gcapcPeaks.r
\name{gcapcPeaks}
\alias{gcapcPeaks}
\title{GC Effects Aware Peak Calling}
\usage{
gcapcPeaks(coverage, gcbias, bdwidth, flank = NULL, prefilter = 4L,
  permute = 5L, pv = 0.05, plot = FALSE, genome = "hg19",
  gctype = c("ladder", "tricube"))
}
\arguments{
\item{coverage}{A list object returned by function \code{read5endCoverage}.}

\item{gcbias}{A list object returned by function \code{gcEffects}.}

\item{bdwidth}{A non-negative integer vector with two elements
specifying ChIP-seq binding width and peak detection half window size.
Usually generated by function \code{bindWidth}. A bad estimation of
bdwidth results no meaning of downstream analysis. The values
need to be the same as it is when calculating \code{gcbias}.}

\item{flank}{A non-negative integer specifying the flanking width of
ChIP-seq binding. This parameter provides the flexibility that reads
appear in flankings by decreased probabilities as increased distance
from binding region. This paramter helps to define effective GC
content calculation. Default is NULL, which means this paramater will
be calculated from \code{bdwidth}. However, if customized numbers
provided, there won't be recalucation for this parameter; instead, the
2nd elements of \code{bdwidth} will be recalculated based on \code{flank}.
The value needs to be the same as it is when calculating \code{gcbias}.}

\item{prefilter}{A non-negative integer specifying the minimum of reads
to qualify a potential binding region. Regions with total of reads from
forward and reverse strands larger or equivalent to \code{prefilter} are
selected for downstream analysis. Default is 4.}

\item{permute}{A non-negative integer specifying times of permutation to
be performed. Default is 5. When whole large genome is used, such as
human genome, 5 times of permutation could be enough.}

\item{pv}{A numeric specifying p-value cutoff for significant
binding peaks. Default is 0.05.}

\item{plot}{A logical vector which, when TRUE (default), returns density
plots of real and permutation enrichment scores.}

\item{genome}{A \link[BSgenome]{BSgenome} object containing the sequences
of the reference genome that was used to align the reads, or the name of
this reference genome specified in a way that is accepted by the
\code{\link[BSgenome]{getBSgenome}} function defined in the \pkg{BSgenome}
software package. In that case the corresponding BSgenome data package
needs to be already installed (see \code{?\link[BSgenome]{getBSgenome}} in
the \pkg{BSgenome} package for the details). The value needs to be the same
as it is when calculating \code{gcbias}.}

\item{gctype}{A character vector specifying choice of method to calculate
effective GC content. Default \code{ladder} is based on uniformed fragment
distribution. A more smoother method based on tricube assumption is also
allowed. However, tricube should be not used if estimated peak half size
is 3 times or more larger than estimated bind width. The value
needs to be the same as it is when calculating \code{gcbias}.}
}
\value{
A GRanges of peaks with meta columns:
\item{es}{Estimated enrichment score.}
\item{pv}{p-value.}
}
\description{
This function calls ChIP-seq peaks using potential GC effects information.
Enrichment scores are calculated on sliding windows of prefiltered
large regions, with GC effects considered. Permutation analysis is
used to determine significant binding peaks.
}
\examples{
bam <- system.file("extdata", "chipseq.bam", package="gcapc")
cov <- read5endCoverage(bam)
bdw <- bindWidth(cov)
gcb <- gcEffects(cov, bdw, sampling = c(0.15,1))
gcapcPeaks(cov, gcb, bdw)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gcEffects.r
\name{gcEffects}
\alias{gcEffects}
\title{ChIP-seq GC Effects Estimation}
\usage{
gcEffects(coverage, bdwidth, flank = NULL, plot = TRUE, sampling = c(0.05,
  1), supervise = GRanges(), gcrange = c(0.3, 0.8), emtrace = TRUE,
  model = c("nbinom", "poisson"), mu0 = 1, mu1 = 50, theta0 = mu0,
  theta1 = mu1, p = 0.02, converge = 0.001, genome = "hg19",
  gctype = c("ladder", "tricube"))
}
\arguments{
\item{coverage}{A list object returned by function \code{read5endCoverage}.}

\item{bdwidth}{A non-negative integer vector with two elements
specifying ChIP-seq binding width and peak detection half window size.
Usually generated by function \code{bindWidth}. A bad estimation of
bdwidth results no meaning of downstream analysis.}

\item{flank}{A non-negative integer specifying the flanking width of
ChIP-seq binding. This parameter provides the flexibility that reads
appear in flankings by decreased probabilities as increased distance
from binding region. This paramter helps to define effective GC
content calculation. Default is NULL, which means this paramater will
be calculated from \code{bdwidth}. However, if customized numbers
provided, there won't be recalucation for this parameter; instead, the
2nd elements of \code{bdwidth} will be recalculated based on \code{flank}.}

\item{plot}{A logical vector which, when TRUE (default), returns plots
of intermediate results.}

\item{sampling}{A numeric vector with length 2. The first number specifies
the proportion of regions to be sampled for GC effects estimation.
The second number specifies the repeat times for sampling.
Default c(0.05,1) gives pretty robust estimation for human genome. However,
smaller genomes might need both higher proportion and more repeat times for
robust estimation.}

\item{supervise}{A GRanges object specifying peak regions in the
studied data, such as peaks called by peak callers, e.g. MACS & SPP. These
peak regions provide supervised window sampling for both mixtures in the
generalized linear model. Default no supervising. Or, if provided peak
regions have too few covered windows, supervised sampling will be replaced
by random sampling automatically.}

\item{gcrange}{A non-negative numeric vector with length 2. This vector
sets the range of GC content to filter regions for GC effect estimation.
For human, most regions have GC content between 0.3 and 0.8, which is
set as the default. Other regions with GC content beyond this range
will be ignored. This range is critical when very few foreground regions
are selected for mixture model fitting, since outliers could drive the
regression lines. Thus, if possible, first make a scatter plot between
counts and GC content to decide  this parameter. Alternatively,
select a narrower range, e.g. c(0.35,0.7), to aviod outlier effects from
both high and low GC-content regions.}

\item{emtrace}{A logical vector which, when TRUE (default), allows to
print the trace of log likelihood changes in EM iterations.}

\item{model}{A character specifying the distribution model to be used in
generalized linear model fitting. The default is negative
binomial(\code{nbinom}), while \code{poisson} is also supported currently.
Based on our tests of multiple datasets, mostly poisson is a very good
approximation of negative binomial, and provides much faster model fitting.}

\item{mu0}{A non-negative numeric initiating read count signals for
background regions. This is treated as the starting value of background mean
for poisson/nbinom fitting. Default is 1.}

\item{mu1}{A non-negative numeric initiating read count signals for
foreground regions. This is treated as the starting value of foreground mean
for poisson/nbinom fitting, Default is 50.}

\item{theta0}{A non-negative numeric initiating the shape parameter of
negative binomial model for background regions. For more detail, see
theta in \code{\link[MASS]{glm.nb}} function.}

\item{theta1}{A non-negative numeric initiating the shape parameter of
negative binomial model for foreground regions. For more detail, see
theta in \code{\link[MASS]{glm.nb}} function.}

\item{p}{A non-negative numeric specifying the proportion of foreground
regions in all estimated regions. This is treated as a starting value for
EM algorithm. Default is 0.02.}

\item{converge}{A non-negative numeric specifying the condition of EM
algorithm termination. EM algorithm stops when the ratio of log likelihood
increment to whole log likelihood is less or equivalent to
\code{converge}.}

\item{genome}{A \link[BSgenome]{BSgenome} object containing the sequences
of the reference genome that was used to align the reads, or the name of
this reference genome specified in a way that is accepted by the
\code{\link[BSgenome]{getBSgenome}} function defined in the \pkg{BSgenome}
software package. In that case the corresponding BSgenome data package
needs to be already installed (see \code{?\link[BSgenome]{getBSgenome}} in
the \pkg{BSgenome} package for the details).}

\item{gctype}{A character vector specifying choice of method to calculate
effective GC content. Default \code{ladder} is based on uniformed fragment
distribution. A more smoother method based on tricube assumption is also
allowed. However, tricube should be not used if estimated peak half size
is 3 times or more larger than estimated bind width.}
}
\value{
A list of objects
\item{gc}{The GC contents at which GC effects are estimated.}
\item{mu0}{Predicted background signals at GC content \code{gc}.}
\item{mu1}{Predicted foreground signals at GC content \code{gc} .}
\item{mu0med0}{Median of predicted background signals.}
\item{mu1med1}{Median of predicted foreground signals.}
\item{mu0med1}{Median of predicted background signals at GC content of
foreground windows.}
\item{mu1med0}{Median of predicted foreground signals at GC content of
background windows.}
}
\description{
GC effects are estimated based on effective GC content and reads count
on genome-wide windows, using generalized linear mixture models. Genome
wide windows are randomly or supervised sampled with given proportions.
GC effects of background and foreground are estimated separately.
}
\examples{
bam <- system.file("extdata", "chipseq.bam", package="gcapc")
cov <- read5endCoverage(bam)
bdw <- bindWidth(cov)
gcb <- gcEffects(cov, bdw, sampling = c(0.15,1))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read5endCoverage.r
\name{read5endCoverage}
\alias{read5endCoverage}
\title{Reads Coverage Using 5-end Base}
\usage{
read5endCoverage(bam, chroms = NULL, mapq = 30L, duplicate = FALSE,
  flag = scanBamFlag(isUnmappedQuery = FALSE, isSecondaryAlignment = FALSE,
  isNotPassingQualityControls = FALSE))
}
\arguments{
\item{bam}{The path to a BAM file, which is sorted and indexed.}

\item{chroms}{NULL or a vector of chromosome names that compatible with
the provided BAM file. Reads coverage will be generated for these
chromosomes. Default (NULL) will use all chromosomes in BAM file.}

\item{mapq}{A non-negative integer specifying the minimum mapping
quality to include. BAM records with mapping qualities less
than \code{mapq} are discarded.}

\item{duplicate}{A logical vector which, when FALSE (Default), returns
maximum coverage of 1 for every base pair. Reads that start at the same
position but on different strands are not treated as duplicates.}

\item{flag}{A returned object by \code{Rsamtools::scanBamFlag}.
Additional options for BAM records filtering.}
}
\value{
A list of two objects by \code{GenomicRanges::coverage}
\item{fwd}{Coverage object for forward strand.}
\item{rev}{Coverage object for reverse strand.}
}
\description{
Reads coverage in single base pair resolution using only 5-prime end
of BAM file records. Coverages are reported for forward and reverse
strands separately. Options for customized filtering of BAM records
are provided.
}
\examples{
bam <- system.file("extdata", "chipseq.bam", package="gcapc")
read5endCoverage(bam)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/refineSites.r
\name{refineSites}
\alias{refineSites}
\title{Adjust ChIP-seq Read Count Table}
\usage{
refineSites(counts, sites, flank = 250L, outputidx = rep(TRUE,
  nrow(counts)), gcrange = c(0.3, 0.8), emtrace = TRUE, plot = TRUE,
  model = c("nbinom", "poisson"), mu0 = 1, mu1 = 50, theta0 = mu0,
  theta1 = mu1, p = 0.2, converge = 1e-04, genome = "hg19",
  gctype = c("ladder", "tricube"))
}
\arguments{
\item{counts}{A count matrix with each row corresponding to each element
in \code{sites} and each column corresponding to one sample. Every value
in the matrix indicates the read counts for one site in one sample. It is
noted that since effective GC content is used in this function, it is
important to extend either original reads or original \code{sites} to
consider reads that 5' starting in \code{flank} regions, when counting
sequencing reads.}

\item{sites}{A GRanges object with length equivalent to number of rows
in \code{counts} matrix. It is preferable that every GRange have the same
width; otherwise, the mixture model is modeling different things with
wider GRanges certainly have more reads. However, it is OK if only a
minority of GRanges have different width, since the model is pretty robust
to outliers. Also, it is important that \code{sites} including both
foreground and background regions in each sample, otherwise the mixture
model will fail to fit two components. Fortunately, if you are inputing
a large collection of samples, foreground sites in one sample may play
the role as background in other samples. In this case, manually selecting
real background is not necessary.}

\item{flank}{A non-negative integer specifying the flanking width of
ChIP-seq binding. This parameter provides the flexibility that reads
appear in flankings by decreased probabilities as increased distance
from binding region. This paramter helps to define effective GC
content calculation.}

\item{outputidx}{A logical vector with the length equivalent to number
of rows in \code{counts}. This provides which subset of adjusted count
matrix should be outputed. This would be extremely useful if you have
manually collected background sites and want to only export the sites
you care about.}

\item{gcrange}{A non-negative numeric vector with length 2. This vector
sets the range of GC content to filter regions for GC effect estimation.
For human, most regions have GC content between 0.3 and 0.8, which is
set as the default. Other regions with GC content beyond this range
will be ignored. This range is critical when very few foreground regions
are selected for mixture model fitting, since outliers could drive the
regression lines. Thus, if possible, first make a scatter plot between
counts and GC content to decide  this parameter. Alternatively,
select a narrower range, e.g. c(0.35,0.7), to aviod outlier effects from
both high and low GC-content regions.}

\item{emtrace}{A logical vector which, when TRUE (default), allows to
print the trace of log likelihood changes in EM iterations.}

\item{plot}{A logical vector which, when TRUE (default), returns miture
fitting plot.}

\item{model}{A character specifying the distribution model to be used in
generalized linear model fitting. The default is negative
binomial(\code{nbinom}), while \code{poisson} is also supported currently.
More details see \code{gcEffects}.}

\item{mu0}{A non-negative numeric initiating read count signals for
background sites. This is treated as the starting value of background mean
for poisson/nbinom fitting.}

\item{mu1}{A non-negative numeric initiating read count signals for
foreground sites. This is treated as the starting value of foreground mean
for poisson/nbinom fitting.}

\item{theta0}{A non-negative numeric initiating the shape parameter of
negative binomial model for background sites. For more detail, see
theta in \code{\link[MASS]{glm.nb}} function.}

\item{theta1}{A non-negative numeric initiating the shape parameter of
negative binomial model for foreground sites. For more detail, see
theta in \code{\link[MASS]{glm.nb}} function.}

\item{p}{A non-negative numeric specifying the proportion of foreground
sites in all estimated sites. This is treated as a starting value for
EM algorithm.}

\item{converge}{A non-negative numeric specifying the condition of EM
algorithm termination. EM algorithm stops when the ratio of log likelihood
increment to whole log likelihood is less or equivalent to
\code{converge}.}

\item{genome}{A \link[BSgenome]{BSgenome} object containing the sequences
of the reference genome that was used to align the reads, or the name of
this reference genome specified in a way that is accepted by the
\code{\link[BSgenome]{getBSgenome}} function defined in the \pkg{BSgenome}
software package. In that case the corresponding BSgenome data package
needs to be already installed (see \code{?\link[BSgenome]{getBSgenome}} in
the \pkg{BSgenome} package for the details).}

\item{gctype}{A character vector specifying choice of method to calculate
effective GC content. Default \code{ladder} is based on uniformed fragment
distribution. A more smoother method based on tricube assumption is also
allowed. However, tricube should be not used if \code{flank} is too large.}
}
\value{
The count matrix after GC adjustment. The matrix values are not
integer any more.
}
\description{
For a given set of sites with the same/comparable width, their
read count table from multiple samples are adjusted based on
potential GC effects. For each sample separately, GC effects are
estimated based on their effective GC content and
reads count using generalized linear mixture models. Then, count
table is adjusted based on estimated GC effects.
It it important that the given sites includes both foreground and
background regions, see \code{sites} below.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bindWidth.r
\name{bindWidth}
\alias{bindWidth}
\title{ChIP-seq Binding Width And Peak Window Size Estimation}
\usage{
bindWidth(coverage, range = c(50L, 500L), step = 50L, odd = TRUE)
}
\arguments{
\item{coverage}{A list object returned by function \code{read5endCoverage}.}

\item{range}{A non-nagative integer vector with length 2. This vector
set the range within which binding width and peak window size are 
estimated. Default c(50,500) represents most ChIP-seq experiments.}

\item{step}{A non-negative integer to set the resolution of binding
width estimation within \code{range}. This value will be tuned if
\code{auto} is TRUE. Default 50 is based on default value of 
\code{range}.}

\item{odd}{A logical vector which, when TRUE, only allows return odd
number of binding width, which is preferred by the 
effective GC content estimation. Default: TRUE.}
}
\value{
A numeric vector with 2 elements:
Estimated binding width and half size of peak detection window.
}
\description{
ChIP-seq experiments usually use crosslinking strategy to capture
sequencing fragments. The fragment location is affected by at least but
not limited to two factors, protein real binding and crosslinking
operation. This function estimate size of binding part in crosslinked
DNA-protein complexes, and denoted that as ChIP-seq binding width.Also,
the peak detection window half size is estimated based on binding width.
}
\examples{
bam <- system.file("extdata", "chipseq.bam", package="gcapc")
cov <- read5endCoverage(bam)
bindWidth(cov)
}
